# Learn Java 17 Programming - Second Edition

<a href="https://www.packtpub.com/product/learn-java-17-programming-second-edition/9781803241432?utm_source=github&utm_medium=repository&utm_campaign=9781803241432"><img src="https://static.packt-cdn.com/products/9781803241432/cover/smaller" alt="Learn Java 17 Programming - Second Edition" height="256px" align="right"></a>

This is the code repository for [Learn Java 17 Programming - Second Edition](https://www.packtpub.com/product/learn-java-17-programming-second-edition/9781803241432?utm_source=github&utm_medium=repository&utm_campaign=9781803241432), published by Packt.

**Learn the fundamentals of Java Programming with this updated guide with the latest features**

## What is this book about?
Java is one of the most preferred languages among developers. It is used in everything right from smartphones and game consoles to even supercomputers, and its new features simply add to the richness of the language. 

This book covers the following exciting features:
* Understand and apply object-oriented principles in Java
* Explore Java design patterns and best practices to solve everyday problems
* Build user-friendly and attractive GUIs with ease
* Understand the usage of microservices with the help of practical examples
* Discover techniques and idioms for writing high-quality Java code
* Get to grips with the usage of data structures in Java

If you feel this book is for you, get your [copy](https://www.amazon.com/dp/1803241438) today!

<a href="https://www.packtpub.com/?utm_source=github&utm_medium=banner&utm_campaign=GitHubBanner"><img src="https://raw.githubusercontent.com/PacktPublishing/GitHub/master/GitHub.png" 
alt="https://www.packtpub.com/" border="5" /></a>

## Instructions and Navigations
All of the code is organized into folders. For example, Chapter02.

The code will look like the following:
```
void someMethod(String s){
    try {
	method(s);
    }
	catch (NullPointerException ex){
	//do something    
	} catch (Exception ex){
	//do something else
  }
}
```

**Following is what you need for this book:**
This book is for those who would like to start a new career in the modern Java programming profession, as well as those who do it professionally already and would like to refresh their knowledge of the latest Java and related technologies and ideas.

We also provide a PDF file that has color images of the screenshots/diagrams used in this book. [Click here to download it](https://packt.link/CQqKD).

### Related products
*  Designing Hexagonal Architecture with Java [[Packt]](https://www.packt.com/product/programming/b17571-designing-hexagonal-architecture-with-java/?utm_source=github&utm_medium=repository&utm_campaign=9781801073240) [[Amazon]](https://www.amazon.com/dp/1801816484)

*  The Complete Coding Interview Guide in Java [[Packt]](https://www.packt.com/product/programming/b15403-the-complete-coding-interview-guide-in-java/?utm_source=github&utm_medium=repository&utm_campaign=9781800568754) [[Amazon]](https://www.amazon.com/dp/1839212063)

## Get to Know the Author
**Nick Samoylov**
graduated from Moscow Institute of Physics and Technology, has worked as a theoretical physicist, and learned to program as a tool for testing his mathematical models. After the demise of the USSR, Nick created and successfully ran a software company, but was forced to close it under the pressure of governmental and criminal rackets. In 1999, with his wife Luda and two daughters, he emigrated to the USA and has been living in Colorado since then, working as a Java programmer. In his free time, Nick likes to write and hike in the Rocky Mountains

## Other books by the authors
[Quick Introduction to Modules](https://www.packtpub.com/application-development/java-high-performance-apps-java-9?utm_source=github&utm_medium=repository&utm_campaign=9781789130515)
